xref: /openbmc/linux/scripts/Kbuild.include (revision 31e67366)
1# SPDX-License-Identifier: GPL-2.0
2####
3# kbuild: Generic definitions
4
5# Convenient variables
6comma   := ,
7quote   := "
8squote  := '
9empty   :=
10space   := $(empty) $(empty)
11space_escape := _-_SPACE_-_
12pound := \#
13
14###
15# Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
16dot-target = $(dir $@).$(notdir $@)
17
18###
19# The temporary file to save gcc -MMD generated dependencies must not
20# contain a comma
21depfile = $(subst $(comma),_,$(dot-target).d)
22
23###
24# filename of target with directory and extension stripped
25basetarget = $(basename $(notdir $@))
26
27###
28# real prerequisites without phony targets
29real-prereqs = $(filter-out $(PHONY), $^)
30
31###
32# Escape single quote for use in echo statements
33escsq = $(subst $(squote),'\$(squote)',$1)
34
35###
36# Quote a string to pass it to C files. foo => '"foo"'
37stringify = $(squote)$(quote)$1$(quote)$(squote)
38
39###
40# Easy method for doing a status message
41       kecho := :
42 quiet_kecho := echo
43silent_kecho := :
44kecho := $($(quiet)kecho)
45
46###
47# filechk is used to check if the content of a generated file is updated.
48# Sample usage:
49#
50# filechk_sample = echo $(KERNELRELEASE)
51# version.h: FORCE
52#	$(call filechk,sample)
53#
54# The rule defined shall write to stdout the content of the new file.
55# The existing file will be compared with the new one.
56# - If no file exist it is created
57# - If the content differ the new file is used
58# - If they are equal no change, and no timestamp update
59define filechk
60	$(Q)set -e;						\
61	mkdir -p $(dir $@);					\
62	trap "rm -f $(dot-target).tmp" EXIT;			\
63	{ $(filechk_$(1)); } > $(dot-target).tmp;		\
64	if [ ! -r $@ ] || ! cmp -s $@ $(dot-target).tmp; then	\
65		$(kecho) '  UPD     $@';			\
66		mv -f $(dot-target).tmp $@;			\
67	fi
68endef
69
70######
71# gcc support functions
72# See documentation in Documentation/kbuild/makefiles.rst
73
74# cc-cross-prefix
75# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
76# Return first <prefix> where a <prefix>gcc is found in PATH.
77# If no gcc found in PATH with listed prefixes return nothing
78#
79# Note: '2>/dev/null' is here to force Make to invoke a shell. Otherwise, it
80# would try to directly execute the shell builtin 'command'. This workaround
81# should be kept for a long time since this issue was fixed only after the
82# GNU Make 4.2.1 release.
83cc-cross-prefix = $(firstword $(foreach c, $(1), \
84			$(if $(shell command -v -- $(c)gcc 2>/dev/null), $(c))))
85
86# output directory for tests below
87TMPOUT = $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_$$$$
88
89# try-run
90# Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
91# Exit code chooses option. "$$TMP" serves as a temporary file and is
92# automatically cleaned up.
93try-run = $(shell set -e;		\
94	TMP=$(TMPOUT)/tmp;		\
95	TMPO=$(TMPOUT)/tmp.o;		\
96	mkdir -p $(TMPOUT);		\
97	trap "rm -rf $(TMPOUT)" EXIT;	\
98	if ($(1)) >/dev/null 2>&1;	\
99	then echo "$(2)";		\
100	else echo "$(3)";		\
101	fi)
102
103# as-option
104# Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
105
106as-option = $(call try-run,\
107	$(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
108
109# as-instr
110# Usage: cflags-y += $(call as-instr,instr,option1,option2)
111
112as-instr = $(call try-run,\
113	printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
114
115# __cc-option
116# Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
117__cc-option = $(call try-run,\
118	$(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
119
120# cc-option
121# Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
122
123cc-option = $(call __cc-option, $(CC),\
124	$(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS),$(1),$(2))
125
126# cc-option-yn
127# Usage: flag := $(call cc-option-yn,-march=winchip-c6)
128cc-option-yn = $(call try-run,\
129	$(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
130
131# cc-disable-warning
132# Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
133cc-disable-warning = $(call try-run,\
134	$(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
135
136# cc-ifversion
137# Usage:  EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
138cc-ifversion = $(shell [ $(CONFIG_GCC_VERSION)0 $(1) $(2)000 ] && echo $(3) || echo $(4))
139
140# ld-option
141# Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
142ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
143
144# ld-ifversion
145# Usage:  $(call ld-ifversion, -ge, 22252, y)
146ld-ifversion = $(shell [ $(CONFIG_LD_VERSION)0 $(1) $(2)0 ] && echo $(3) || echo $(4))
147
148######
149
150###
151# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
152# Usage:
153# $(Q)$(MAKE) $(build)=dir
154build := -f $(srctree)/scripts/Makefile.build obj
155
156###
157# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
158# Usage:
159# $(Q)$(MAKE) $(dtbinst)=dir
160dtbinst := -f $(srctree)/scripts/Makefile.dtbinst obj
161
162###
163# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
164# Usage:
165# $(Q)$(MAKE) $(clean)=dir
166clean := -f $(srctree)/scripts/Makefile.clean obj
167
168# echo command.
169# Short version is used, if $(quiet) equals `quiet_', otherwise full one.
170echo-cmd = $(if $($(quiet)cmd_$(1)),\
171	echo '  $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
172
173# printing commands
174cmd = @set -e; $(echo-cmd) $(cmd_$(1))
175
176###
177# if_changed      - execute command if any prerequisite is newer than
178#                   target, or command line has changed
179# if_changed_dep  - as if_changed, but uses fixdep to reveal dependencies
180#                   including used config symbols
181# if_changed_rule - as if_changed but execute rule instead
182# See Documentation/kbuild/makefiles.rst for more info
183
184ifneq ($(KBUILD_NOCMDDEP),1)
185# Check if both commands are the same including their order. Result is empty
186# string if equal. User may override this check using make KBUILD_NOCMDDEP=1
187cmd-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
188                         $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
189else
190cmd-check = $(if $(strip $(cmd_$@)),,1)
191endif
192
193# Replace >$< with >$$< to preserve $ when reloading the .cmd file
194# (needed for make)
195# Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
196# (needed for make)
197# Replace >'< with >'\''< to be able to enclose the whole string in '...'
198# (needed for the shell)
199make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
200
201# Find any prerequisites that are newer than target or that do not exist.
202# (This is not true for now; $? should contain any non-existent prerequisites,
203# but it does not work as expected when .SECONDARY is present. This seems a bug
204# of GNU Make.)
205# PHONY targets skipped in both cases.
206newer-prereqs = $(filter-out $(PHONY),$?)
207
208# Execute command if command has changed or prerequisite(s) are updated.
209if_changed = $(if $(newer-prereqs)$(cmd-check),                              \
210	$(cmd);                                                              \
211	printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
212
213# Execute the command and also postprocess generated .d dependencies file.
214if_changed_dep = $(if $(newer-prereqs)$(cmd-check),$(cmd_and_fixdep),@:)
215
216cmd_and_fixdep =                                                             \
217	$(cmd);                                                              \
218	scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).cmd;\
219	rm -f $(depfile)
220
221# Usage: $(call if_changed_rule,foo)
222# Will check if $(cmd_foo) or any of the prerequisites changed,
223# and if so will execute $(rule_foo).
224if_changed_rule = $(if $(newer-prereqs)$(cmd-check),$(rule_$(1)),@:)
225
226###
227# why - tell why a target got built
228#       enabled by make V=2
229#       Output (listed in the order they are checked):
230#          (1) - due to target is PHONY
231#          (2) - due to target missing
232#          (3) - due to: file1.h file2.h
233#          (4) - due to command line change
234#          (5) - due to missing .cmd file
235#          (6) - due to target not in $(targets)
236# (1) PHONY targets are always build
237# (2) No target, so we better build it
238# (3) Prerequisite is newer than target
239# (4) The command line stored in the file named dir/.target.cmd
240#     differed from actual command line. This happens when compiler
241#     options changes
242# (5) No dir/.target.cmd file (used to store command line)
243# (6) No dir/.target.cmd file and target not listed in $(targets)
244#     This is a good hint that there is a bug in the kbuild file
245ifeq ($(KBUILD_VERBOSE),2)
246why =                                                                        \
247    $(if $(filter $@, $(PHONY)),- due to target is PHONY,                    \
248        $(if $(wildcard $@),                                                 \
249            $(if $(newer-prereqs),- due to: $(newer-prereqs),                \
250                $(if $(cmd-check),                                           \
251                    $(if $(cmd_$@),- due to command line change,             \
252                        $(if $(filter $@, $(targets)),                       \
253                            - due to missing .cmd file,                      \
254                            - due to $(notdir $@) not in $$(targets)         \
255                         )                                                   \
256                     )                                                       \
257                 )                                                           \
258             ),                                                              \
259             - due to target missing                                         \
260         )                                                                   \
261     )
262
263echo-why = $(call escsq, $(strip $(why)))
264endif
265
266###############################################################################
267#
268# When a Kconfig string contains a filename, it is suitable for
269# passing to shell commands. It is surrounded by double-quotes, and
270# any double-quotes or backslashes within it are escaped by
271# backslashes.
272#
273# This is no use for dependencies or $(wildcard). We need to strip the
274# surrounding quotes and the escaping from quotes and backslashes, and
275# we *do* need to escape any spaces in the string. So, for example:
276#
277# Usage: $(eval $(call config_filename,FOO))
278#
279# Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
280# transformed as described above to be suitable for use within the
281# makefile.
282#
283# Also, if the filename is a relative filename and exists in the source
284# tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
285# be prefixed to *both* command invocation and dependencies.
286#
287# Note: We also print the filenames in the quiet_cmd_foo text, and
288# perhaps ought to have a version specially escaped for that purpose.
289# But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
290# enough.  It'll strip the quotes in the common case where there's no
291# space and it's a simple filename, and it'll retain the quotes when
292# there's a space. There are some esoteric cases in which it'll print
293# the wrong thing, but we don't really care. The actual dependencies
294# and commands *do* get it right, with various combinations of single
295# and double quotes, backslashes and spaces in the filenames.
296#
297###############################################################################
298#
299define config_filename
300ifneq ($$(CONFIG_$(1)),"")
301$(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
302ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
303else
304ifeq ($$(wildcard $$($(1)_FILENAME)),)
305ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
306$(1)_SRCPREFIX := $(srctree)/
307endif
308endif
309endif
310endif
311endef
312#
313###############################################################################
314
315# delete partially updated (i.e. corrupted) files on error
316.DELETE_ON_ERROR:
317
318# do not delete intermediate files automatically
319.SECONDARY:
320